	LIST		P=16F84
        ERRORLEVEL      -207    ; Suppress "Label after column 1"-Messages

_ClkIn		equ	4000000	; Input Clock Frequency Of PIC16f84
#define	_Sync0	PORTB,0
#define	_Sync1	PORTB,1
#define	_Sync2	PORTB,2
#define	_Led	PORTB,3

	include		"p16f84.inc"	; system defs
	include		"jmp.inc"	; 
	RADIX	DEC
	__CONFIG	_XT_OSC & _WDT_ON & _PWRTE_ON & _CP_OFF
;--------------------------------------------------------------------------
; This project to syncronize some video cameras on Ext.Sync
; for get syncronized it's video signals
; (c) Eugene A. Kalinin 2001
; start    30.07.2001
; finished 30.07.2001 
;--------------------------------------------------------------------------
#define	SEL_BANK_0	bcf	STATUS,RP0	; Select Bank 0
#define	SEL_BANK_1	bsf	STATUS,RP0	; Select Bank 1
#define	CARRY		STATUS,C
#define	ZERO		STATUS,Z


TRUE	equ	1
FALSE	equ	0

LSB	equ	0
MSB	equ	7

#define test FALSE	;TRUE

cblock	0Ch
	WBuffer		:	1	;save W while ints
	StatBuffer	:	1	;save STATUS while ints
;	StFSR		:	1	;to  store FSR
;	state		:	1	;sate of the state machine
;	MyFlags		:	1	;flags for delay routing
	TmpRegister	:	1	;
	temp		:	1	;b2_bcd temp byte
	temp1		:	1	;b2_bcd temp byte
	temp2		:	1	;b2_bcd temp byte
	temp3		:	1	;b2_bcd temp byte
	temp4		:	1	;b2_bcd temp byte
	temp1s		:	1	;1s temp byte
endc

;==========================================================
;---------------M--A--C--R--O--S---------------------------
;==========================================================
;------------------------------
; Parameters of macro:
;   VALUE:      Constant represent a delay
;              ((VALUE-1)*4+5)*(1/(Fosc/4))
;		Value=((USec-5) div 4)+1 on 4MHz
;------------------------------
DELAY		MACRO	VALUE
		LOCAL   REDO

		movlw   VALUE
		movwf   TmpRegister
	REDO:		;nop	;
			clrwdt	;Clear watch dog timer
			decfsz  TmpRegister,1
			goto    REDO
		ENDM

InvertHalfLineSyncMacro MACRO		; Total - 32 USec
	bcf	_Sync0			; 27 USec HSync
	bcf	_Sync1
	bcf	_Sync2
	DELAY	5			; 21 USec
	nop
	nop
	nop
	bsf	_Sync0			; 5 USec Inverse Impulse
	bsf	_Sync1
	bsf	_Sync2
	nop
	nop
	ENDM

HalfLineSyncMacro	MACRO		; Total - 28 USec
	bcf	_Sync0			; 5 USec HSync
	bcf	_Sync1
	bcf	_Sync2
	nop
	nop
	bsf	_Sync0
	bsf	_Sync1
	bsf	_Sync2
	DELAY	4			; 17 USec
	nop
	nop
	nop
	ENDM

;==========================================================
		ORG	0000H

		goto	MyStart

		ORG	4
		retfie

;****************************** START *****************************
MyStart:
		;Define	I/O Lines 0=out	1=inp
		; Bit B0 (Inp) Sync0
		; Bit B1 (Inp) Sync1
		; Bit B2 (Out) Sync2
		; Bit B7 (Out) Led

		clrf	INTCON		;clear all ints

		SEL_BANK_1
		MOVLW	11111111b
		MOVWF	TRISA
		MOVLW	11110000b
		MOVWF	TRISB
		SEL_BANK_0

		CLRF	PORTA
		CLRF	PORTB
		movf	PORTB,7

	GlobalLoop:
;			movlw	5		; 1-st Field
;			movwf	temp2
;		InvertHalfLinesLoop1:		; Zero-Time - 2 USec (by call-time)
;				call	InvertHalfLineSync
;				decfsz	temp2,F
;				goto	InvertHalfLinesLoop1_Cont
;				goto	InvertHalfLinesLoop1_Ex
;			InvertHalfLinesLoop1_Cont:
;				nop
;				goto	InvertHalfLinesLoop1
;		InvertHalfLinesLoop1_Ex:

			clrwdt
			nop
			nop
			bsf	_Led
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro

			HalfLineSyncMacro

			movlw	4
			movwf	temp2
		HalfLinesLoop1:
				call	HalfLineSync
				decfsz	temp2,F
				goto	HalfLinesLoop1_Cont
				goto	HalfLinesLoop1_Ex
			HalfLinesLoop1_Cont:
				nop
				goto	HalfLinesLoop1
		HalfLinesLoop1_Ex:

			movlw	200
			movwf	temp2
			CFS1:	call	LineSync	; 64 USec lines cycle
				decfsz	temp2,F
				goto	CFS1_Cont
				goto	CFS1_Ex
			CFS1_Cont:
				nop
				goto	CFS1
		CFS1_Ex:

			movlw	105
			movwf	temp2
			CFS11:	call	LineSync	; 64 USec lines cycle
				decfsz	temp2,F
				goto	CFS11_Cont
				goto	CFS11_Ex
			CFS11_Cont:
				nop
				goto	CFS11
		CFS11_Ex:

			movlw	7
			movwf	temp2
		HalfLinesLoop2:
				call	HalfLineSync
				decfsz	temp2,F
				goto	HalfLinesLoop2_Cont
				goto	HalfLinesLoop2_Ex
			HalfLinesLoop2_Cont:
				nop
				goto	HalfLinesLoop2
		HalfLinesLoop2_Ex:

;			movlw	5		; 2-nd Field
;			movwf	temp2
;		InvertHalfLinesLoop2:
;				call	InvertHalfLineSync
;				decfsz	temp2,F
;				goto	InvertHalfLinesLoop2_Cont
;				goto	InvertHalfLinesLoop2_Ex
;			InvertHalfLinesLoop2_Cont:
;				nop
;				goto	InvertHalfLinesLoop2
;		InvertHalfLinesLoop2_Ex:

			nop
			nop
			nop
			bcf	_Led
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro
			InvertHalfLineSyncMacro

			HalfLineSyncMacro

			movlw	3
			movwf	temp2
		HalfLinesLoop3:
				call	HalfLineSync
				decfsz	temp2,F
				goto	HalfLinesLoop3_Cont
				goto	HalfLinesLoop3_Ex
			HalfLinesLoop3_Cont:
				nop
				goto	HalfLinesLoop3
		HalfLinesLoop3_Ex:

			movlw	200
			movwf	temp2
			CFS2:	call	LineSync	; 64 USec lines cycle
				decfsz	temp2,F
				goto	CFS2_Cont
				goto	CFS2_Ex
			CFS2_Cont:
				nop
				goto	CFS2
		CFS2_Ex:

			movlw	105
			movwf	temp2
			CFS21:	call	LineSync	; 64 USec lines cycle
				decfsz	temp2,F
				goto	CFS21_Cont
				goto	CFS21_Ex
			CFS21_Cont:
				nop
				goto	CFS21
		CFS21_Ex:

			movlw	8
			movwf	temp2
		HalfLinesLoop4:
				call	HalfLineSync
				decfsz	temp2,F
				goto	HalfLinesLoop4_Cont
				goto	GlobalLoop
			HalfLinesLoop4_Cont:
				nop
				goto	HalfLinesLoop4

;*********************** Different procedures *********************

Delay20ms:				; 20ms delay
	movlw	20
	movwf	temp
	d20l:	DELAY	255
		decfsz	temp,F
		goto	d20l
	return

Delay1s:				; 1s delay
	movlw	50
	movwf	temp1s
	d1l:	call	Delay20ms
		decfsz	temp1s,F
		goto	d1l
	return

;CommonFieldsSync:
;	movlw	287
;	movwf	temp1
;	CFS:	call	LineSync	; 64 USec lines cycle
;		decfsz	temp1,F
;		goto	CFS
;	return	

LineSync:				; Total - 58 USec (with call & return)
	bcf	_Sync0			; 5 USec HSync
	bcf	_Sync1
	bcf	_Sync2
	nop
	nop
	bsf	_Sync0
	bsf	_Sync1
	bsf	_Sync2
	DELAY	11			; 45 USec
	nop
	return

HalfLineSync:				; Total - 26 USec (with call & return)
	bcf	_Sync0			; 5 USec HSync
	bcf	_Sync1
	bcf	_Sync2
	nop
	nop
	bsf	_Sync0
	bsf	_Sync1
	bsf	_Sync2
	DELAY	3			; 13 USec
	nop
	return

		END


